<template>
  <v-row>
    <v-col class="col-12">
      <v-card class="mx-auto" max-height="450" height="400">
        <v-card-title>
          <p class="text-truncate">
            สรุป % ค่าใช้จ่ายในแต่ละประเภทประจำปี (Bar Horizontal Chart)
            {{ getYear }}
          </p>
        </v-card-title>
        <v-card-text>
          <BarHorizontal />
        </v-card-text>
      </v-card>
    </v-col>
    <v-col class="col-12">
      <v-card class="mx-auto" max-height="450" height="400">
        <v-card-title>
          <p class="text-truncate">
            สรุป % ค่าใช้จ่ายในแต่ละประเภทประจำปี (Doughnut Chart)
            {{ getYear }}
          </p></v-card-title
        >
        <v-card-text>
          <Doughnut />
        </v-card-text>
      </v-card>
    </v-col>
    <v-col class="col-12">
      <v-card class="mx-auto" max-height="500" height="500">
        <v-card-title>
          <p class="text-truncate">
            Staked 100% Bar Chart ข้อมูลค่าใช้จ่ายรวมทั้งหมด จำนวน
            {{ standDardYear }} ปี ระหว่าง ปี {{ startYear }} - {{ endYear }}
          </p>
          <v-spacer />
          <div style="width: 300px">
            <v-subheader class="pl-0 mt-0">
              จำนวนสัปดาห์ (บาร์) ของกราฟ
            </v-subheader>
            <v-slider
              v-model="standDardYear"
              thumb-label="always"
              :max="max"
              :min="min"
            ></v-slider>
          </div>
        </v-card-title>
        <v-card-text><fullStacked :amountYear="standDardYear" /></v-card-text>
      </v-card>
    </v-col>
  </v-row>
</template>
<script>
import covertDate from '@/mixins/formateDate'
import BarHorizontal from '@/components/dashboard/yearly/barHorizontalYearly.vue'
import Doughnut from '@/components/dashboard/yearly/doughnutYearly.vue'
import fullStacked from '@/components/dashboard/yearly/fullStackedYearly.vue'
export default {
  mixins: [covertDate],
  components: {
    BarHorizontal,
    Doughnut,
    fullStacked,
  },
  data: () => ({
    getMonth: '',
    getYear: '',
    startYear: '',
    endYear: '',
    standDardYear: 10,
    amountYear: '',
    min: 1,
    max: 20,
  }),
  computeds: {},
  mounted() {
    this.getDataAxios()
  },
  watch: {
    standDardYear(newVal, oldVal) {
      this.getDataAxios(
        this.$nuxt.$store.state.template.dashboardTime,
        this.$nuxt.$store.state.expensestable.ExpensesTable,
        this.$nuxt.$store.state.expensestype.ExpensesType,
        this.standDardYear
      )
    },
  },
  methods: {
    async getDataAxios(
      timeVal = new Date(),
      expensestable = 0,
      expensestype = 0,
      amount = 0
    ) {
      if (amount > 0) {
        const checkTime = timeVal
        const date = new Date(checkTime)

        const amountYear = amount

        const firstDay = new Date(date.getFullYear(), 0, 1)
        const lastDay = new Date(date.getFullYear(), 11, 31)

        const dayStart =
          firstDay.getTime() - Math.floor(amountYear / 2) * (365 * 86400000)
        const dayEnd =
          lastDay.getTime() + Math.floor(amountYear / 2) * (365 * 86400000)

        const firstYear = new Date(dayStart)
        const lastYear = new Date(dayEnd)

        this.getYear = date.getFullYear() + 543

        this.startYear = firstYear.getFullYear() + 543
        this.endYear = lastYear.getFullYear() + 543
      }
    },
  },
}
</script>
<style scoped>
.v-card__title p {
  color: #6e6e6e;
  line-height: 1.33;
  margin: 0;
  font-size: 20px;
  font-weight: 400;
}
</style>
